## rustc 1.25.0+dfsg1+llvm

=== src/test/run-make/hotplug_codegen_backend/Makefile ===
include ../tools.mk

all:
	/bin/echo || exit 0 # This test requires /bin/echo to exist
	$(RUSTC) the_backend.rs --crate-name the_backend --crate-type dylib \
		-o $(TMPDIR)/the_backend.dylib
	$(RUSTC) some_crate.rs --crate-name some_crate --crate-type bin -o $(TMPDIR)/some_crate \
		-Z codegen-backend=$(TMPDIR)/the_backend.dylib -Z unstable-options
	grep -x "This has been \"compiled\" succesfully." $(TMPDIR)/some_crate

=== debian/changelog ===
rustc (1.25.0+dfsg1+llvm-0ubuntu1~17.10.1) artful; urgency=medium

  * Backport 1.25.0 to artful

 -- Chris Coulson <chris.coulson@canonical.com>  Mon, 23 Apr 2018 16:33:35 +0100

rustc (1.25.0+dfsg1+llvm-0ubuntu1) bionic; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Don't run dynamic_lib::tests::test_loading_cosine on Aarch64 whilst if
      fails there
      - add debian/patches/u-ignoretest-arm64_02.patch
      - update debian/patches/series
    - Make test failures fatal, except on ppc64el and s390x, as there's nothing
      in the archive yet that requires a working rust on these architectures
      - update debian/rules
    - Only build debuginfo for libstd on i386
      - update debian/rules
    - Ensure the build uses the bundled stage0 rustc when bootstrapping
      - update debian/rules
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Make RustdocTheme test work on builds where rust.rpath = false
      - add debian/patches/u-fix-rustdoc-theme-test-without-rpath.patch
      - update debian/patches/series
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests. This isn't a proper fix and needs further
      investigation
      - update debian/control
    - Ignore test failures on Aarch64. Upstream aren't even running tests on
      this architecture so let's not care about test failures there
      - update debian/rules

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 10 Apr 2018 16:12:33 +0100

rustc (1.25.0+dfsg1-1~exp2) experimental; urgency=medium

  * Install missing codegen-backends.

 -- Ximin Luo <infinity0@debian.org>  Fri, 06 Apr 2018 14:05:36 -0700

rustc (1.25.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update to LLVM 6.0.

 -- Ximin Luo <infinity0@debian.org>  Sun, 01 Apr 2018 15:59:47 +0200

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
 Luca Bruno <lucab@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               python:native,
               cargo:native (>= 0.19.0)      <!pkg.rustc.dlstage0>,
               rustc:native (>= 1.24.0+dfsg) <!pkg.rustc.dlstage0>,
               rustc:native (<= 1.25.0++)    <!pkg.rustc.dlstage0>,
               autotools-dev,
               cmake (>= 3.0) | cmake3,
               gperf,
# this is sometimes needed by rustc_llvm
               zlib1g-dev:native,
               zlib1g-dev,
# used by rust-installer
               liblzma-dev:native,
# Required for llvm build
               m4,
# test dependencies:
               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# below are optional tools even for 'make check'
               gdb (>= 7.12) <!nocheck>,
               libc6-dbg [armhf],
# Work around #864741. The version constraint for gdb above should already do
# that, but this will keep things covered even in the case that they change
# gdb-minimal to do a versioned Provides: gdb.
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
               curl <pkg.rustc.dlstage0>,
               ca-certificates <pkg.rustc.dlstage0>,
Build-Conflicts: gdb-minimal <!nocheck>,
                 rustc:native (= 1.25.0+dfsg1-1~exp1)
# ^ That version of rustc is broken
Standards-Version: 4.1.3
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends: rust-gdb | rust-lldb
Suggests: rust-doc, rust-src
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.25
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libstd-rust-1.25 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-6.0, ${misc:Depends}, python-lldb-6.0
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Recommends: cargo-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control

include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
# set remap-path-prefix for reproducible builds; TODO: remove "if" after 1.20
ifeq (0,$(shell dpkg --compare-versions "$$(rustc --version --verbose | sed -ne 's/^release: //p')" '>=' 1.19.0; echo $$?))
RUSTFLAGS += -Zremap-path-prefix-from=$(CURDIR) -Zremap-path-prefix-to=/usr/src/rustc-$(RUST_LONG_VERSION)
export RUSTC_BOOTSTRAP = 1
endif

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Let rustbuild control whether LLVM is compiled with debug symbols, rather
# than compiling with debug symbols unconditionally, which will fail on
# 32-bit architectures
CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUSTBUILD = RUST_BACKTRACE=1 ./x.py
RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
# TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
# an insane blow up in the time it takes to run tests. See upstream #37477 for
# details. Upstream worked around it in #38984 but in Debian we can't take
# advantage of that work-around, because we want as much debuginfo as possible
# (so we set debuginfo-lines = true, debuginfo-only-std = false) so we have to
# work around it instead by disabling backtrace when running tests.
RUSTBUILD_TEST = ./x.py test
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
ENABLE_LOCAL_RUST := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        ENABLE_LOCAL_RUST := true
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
	src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in
	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
		-DBUILD_DOCS="$(BUILD_DOCS)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	$(ENABLE_LOCAL_RUST) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
	# Work around armhf issue: https://github.com/rust-lang/rust/issues/45854
	[ $(DEB_BUILD_ARCH) != armhf -a \
	  $(DEB_BUILD_ARCH) != armel -a \
	  $(DEB_BUILD_ARCH) != i386 ] || sed -i -e '/^debuginfo-only-std = /d' "$@"

debian/rust-src.%: debian/rust-src.%.in
	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
		"$<" > "$@"

override_dh_auto_configure: debian/config.toml
	$(PRECONFIGURE_CHECK)
	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
	# work around #842634
	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
	# We patched mdbook so have to rm the checksums
	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
	# compile it again for rust-installer, see #43449
	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
	debian/prune-checksums src/vendor/backtrace-sys/.cargo-checksum.json
	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16

## rustc 1.28.0+dfsg1+llvm

=== debian/changelog ===
rustc (1.28.0+dfsg1+llvm-0ubuntu2) cosmic; urgency=medium

  * Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an upgrade
    issue
    - update debian/control

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 21 Aug 2018 23:31:55 +0100

rustc (1.28.0+dfsg1+llvm-0ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable, remaining changes: 
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 14 Aug 2018 21:57:50 +0100

rustc (1.28.0+dfsg1-2) unstable; urgency=medium

  * Switch on verbose-tests to restore the old pre-1.28 behaviour, and restore
    old failure-counting logic.
  * Allow 50 test failures on s390x, restored failure-counting logic avoids
    more double-counts.

 -- Ximin Luo <infinity0@debian.org>  Sun, 05 Aug 2018 02:18:10 -0700

rustc (1.28.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Add patches from Fedora to fix some test failures.
  * Ignore a failure testing specific error output, under investigation.
  * Allow 100 test failures on s390x, should be reducible later with LLVM 7.
  * Temporary fix for mips64el bootstrap.
  * Be even more verbose during the build.
  * Update to latest Standards-Version.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Aug 2018 23:04:41 -0700

rustc (1.28.0~beta.14+dfsg1-1~exp2) experimental; urgency=medium

  * Update test-failure counting logic.
  * Fix version constraints for Recommends: cargo.
  * Add patch to fix sparc64 CABI.

 -- Ximin Luo <infinity0@debian.org>  Fri, 27 Jul 2018 04:26:52 -0700

rustc (1.28.0~beta.14+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Wed, 25 Jul 2018 03:11:11 -0700

rustc (1.27.2+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * Update of the alioth ML address.

  [ Ximin Luo ]
  * Fail the build if our version contains ~exp and we are not releasing to
    experimental, this has happened by accident a few times already.
  * Allow 36 and 44 test failures on armel and s390x respectively.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 24 Jul 2018 21:35:56 -0700

rustc (1.27.1+dfsg1-1~exp4) experimental; urgency=medium

  * Unconditonally prune crate checksums to avoid having to manually prune them
    whenever we patch the vendored crates.

 -- Ximin Luo <infinity0@debian.org>  Thu, 19 Jul 2018 14:49:18 -0700

rustc (1.27.1+dfsg1-1~exp3) experimental; urgency=medium

  * Add patch from Fedora to fix rebuild against same version.

 -- Ximin Luo <infinity0@debian.org>  Thu, 19 Jul 2018 08:52:03 -0700

rustc (1.27.1+dfsg1-1~exp2) experimental; urgency=medium

  * Fix some failing tests.

 -- Ximin Luo <infinity0@debian.org>  Wed, 18 Jul 2018 09:06:44 -0700

rustc (1.27.1+dfsg1-1~exp1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 13 Jul 2018 22:58:02 -0700

rustc (1.27.0+dfsg0+llvm-0ubuntu1) cosmic; urgency=medium

  * Update to 1.27.0
  * Bump rustc build requirement to 1.26.0
    - update debian/control
  * Rename libstd-rust-1.26 to libstd-rust-1.27
    - update debian/control
    - debian/libstd-rust-1.26.lintian-overrides =>
        debian/libstd-rust-1.27.lintian-overrides
  * Update debian/copyright
  * Refresh patches
    - update debian/patches/u-fixtestignores-ppc64el.patch
    - update debian/patches/u-tag-private-modules-with-doc-cfg.patch
    - update debian/patches/d-disable-cargo-vendor.patch
    - update debian/patches/d-no-web-dependencies-in-doc.patch
  * Drop patches that are fixed upstream
    - remove debian/patches/u-fix-rustdoc-theme-test-without-rpath.patch
    - remove debian/patches/u-fix-fp-target-warning.patch
    - update debian/patches/series
  * Disable search functionality in the documentation as it depends on
    mark.js and elasticlunr.js, both of which are stripped from the tarball
    (they are vendored in minified form) and neither of which are packaged
    separately in Ubuntu yet
    - add debian/patches/d-disable-doc-search.patch
    - update debian/patches/series

 -- Chris Coulson <chris.coulson@canonical.com>  Fri, 06 Jul 2018 17:02:31 +0100

rustc (1.26.2+dfsg1+llvm-0ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable, remaining changes: 
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Exclude src/tools/lld from the tarball
      - update debian/copyright
      - update debian/rules
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
+XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
  Luca Bruno <lucab@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>,
@@ -13,11 +13,10 @@
                dpkg-dev (>= 1.17.14),
                python:native,
                cargo:native (>= 0.19.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.24.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.25.0++)    <!pkg.rustc.dlstage0>,
+               rustc:native (>= 1.27.0+dfsg) <!pkg.rustc.dlstage0>,
+               rustc:native (<= 1.28.0++)    <!pkg.rustc.dlstage0>,
                autotools-dev,
                cmake (>= 3.0) | cmake3,
-               gperf,
 # this is sometimes needed by rustc_llvm
                zlib1g-dev:native,
                zlib1g-dev,
@@ -38,10 +37,9 @@
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
                curl <pkg.rustc.dlstage0>,
                ca-certificates <pkg.rustc.dlstage0>,
-Build-Conflicts: gdb-minimal <!nocheck>,
-                 rustc:native (= 1.25.0+dfsg1-1~exp1)
+Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 # ^ That version of rustc is broken
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://salsa.debian.org/rust-team/rust.git
 Vcs-Browser: https://salsa.debian.org/rust-team/rust
@@ -52,8 +50,10 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: rust-gdb | rust-lldb
+Recommends: cargo (>= 0.29.0~~), cargo (<< 0.30.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src
+Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
+Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -67,7 +67,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.25
+Package: libstd-rust-1.28
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -92,7 +92,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libstd-rust-1.25 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.28 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly

=== debian/rules ===
--- 
+++ 
@@ -10,27 +10,21 @@
 LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
 # Sed expression that matches the "rustc" we have in our Build-Depends field
 SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control
+# Version of /usr/bin/rustc
+LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')
 
 include /usr/share/dpkg/buildflags.mk
 # TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
 RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
-# set remap-path-prefix for reproducible builds; TODO: remove "if" after 1.20
-ifeq (0,$(shell dpkg --compare-versions "$$(rustc --version --verbose | sed -ne 's/^release: //p')" '>=' 1.19.0; echo $$?))
-RUSTFLAGS += -Zremap-path-prefix-from=$(CURDIR) -Zremap-path-prefix-to=/usr/src/rustc-$(RUST_LONG_VERSION)
-export RUSTC_BOOTSTRAP = 1
+RUSTFLAGS += --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
+ifneq (,$(filter $(DEB_BUILD_ARCH), sparc64))
+export CARGO_INCREMENTAL = 0
 endif
 
 # Defines DEB_*_RUST_TYPE triples
 include debian/architecture.mk
 export DEB_HOST_RUST_TYPE
-
-# Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
-
-# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
-# gcc-6.  See bug #811573.
-CFLAGS += -Wno-misleading-indentation
 
 # Let rustbuild control whether LLVM is compiled with debug symbols, rather
 # than compiling with debug symbols unconditionally, which will fail on
@@ -38,17 +32,13 @@
 CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
 CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
 
-# Release type (one of beta, stable or nightly)
-RELEASE_CHANNEL := stable
-# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
-# out of this packaging. Furthermore, if the build breaks after importing a new
-# upstream stable release, check the do_temporary_fixup function in that file
-# to see if we already know what fix to make.
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
 
 RUSTBUILD = RUST_BACKTRACE=1 ./x.py
-RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
+RUSTBUILD_FLAGS = --config debian/config.toml -vv --on-fail env
 # TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
 # an insane blow up in the time it takes to run tests. See upstream #37477 for
 # details. Upstream worked around it in #38984 but in Debian we can't take
@@ -65,14 +55,14 @@
 update-version:
 	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
 	newver=$(RUST_VERSION); \
-	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi
+	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)
 
 # Below we detect how we're supposed to bootstrap the stage0 compiler. See
 # README.Debian for more details of the cases described below.
 #
 PRECONFIGURE_CHECK = :
 HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
-ENABLE_LOCAL_RUST := false
+DOWNLOAD_BOOTSTRAP := false
 # allow not using the binary tarball although it exists
 #ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
 #  HAVE_BINARY_TARBALL := 0
@@ -86,7 +76,6 @@
     # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
     # In this case, we use the distro's rustc - either the previous or current version.
     ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
-        ENABLE_LOCAL_RUST := true
         # Make it easier to test against a custom rustc
         ifneq (,$(RUST_DESTDIR))
         RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
@@ -98,6 +87,7 @@
     # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
     # We don't need to do anything specific in this build file, so this case is empty.
     else
+        DOWNLOAD_BOOTSTRAP := true
     endif
 else
     # Case B (Bootstrapping a new distro): the extracted source tree does
@@ -126,8 +116,7 @@
 endif
 
 # Build products or non-source files in src/, that shouldn't go in rust-src
-SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
-	src/bootstrap/bootstrap.pyc \
+SRC_CLEAN = src/bootstrap/bootstrap.pyc \
 	src/etc/__pycache__/
 
 # Workaround for linux #865549
@@ -146,16 +135,20 @@
 	# Upstream contains a lot of these
 	dh_clean -XCargo.toml.orig
 
-debian/config.toml: debian/config.toml.in
+debian/config.toml: debian/config.toml.in debian/rules
+	u="$(DEB_VERSION_UPSTREAM)"; \
+	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
+	else channel="stable"; fi; echo $$channel; \
 	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
 		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
 		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
-		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
+		-DRELEASE_CHANNEL="$$channel" \
 		-DBUILD_DOCS="$(BUILD_DOCS)" \
 		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
 		"$<" > "$@"
-	$(ENABLE_LOCAL_RUST) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
+	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
+	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 	# Work around armhf issue: https://github.com/rust-lang/rust/issues/45854
 	[ $(DEB_BUILD_ARCH) != armhf -a \
 	  $(DEB_BUILD_ARCH) != armel -a \
@@ -166,15 +159,21 @@
 		"$<" > "$@"
 
 override_dh_auto_configure: debian/config.toml
+	# fail the build if our version contains ~exp and we are not releasing to experimental
+	v="$(DEB_VERSION)"; test "$$v" = "$${v%~exp*}" -o "$(DEB_DISTRIBUTION)" = "experimental" -o "$(DEB_DISTRIBUTION)" = "UNRELEASED"
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
-	# We patched mdbook so have to rm the checksums
-	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
+	# We patched some crates so have to rm the checksums
+	find src/vendor -name .cargo-checksum.json -execdir "$(CURDIR)/debian/prune-checksums" "{}" ";"
 	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
 	# compile it again for rust-installer, see #43449
 	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
-	debian/prune-checksums src/vendor/backtrace-sys/.cargo-checksum.json
 	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16
+	echo 'fn main() { println!("cargo:rustc-link-lib=lzma"); }' > src/vendor/lzma-sys/build.rs
+	# We don't run ./configure because we use debian/config.toml directly
+	ln -sf debian/config.toml config.toml
+
+override_dh_auto_clean:
